--[[TODO LIST
keep optimizing info transfer
flesh out eraser options
  - make a selection of known names and click to toggle who's stuff you erase?
make time stamps actually do something.  apply them at the proper time
some sort of display showing info being xferred
expand sharing options
pinging tool?
	- add deletion on hide
more icons, colors, options etc
move brush display stuff to better function
protection to stop identical points being created maybe
minimap has its own loaded map?
	load world map areas too
	convert location text to ids instead of changing map
	check map id first if you arent looking at your world map then attempt conversion
]]


local Canvas = addon
local addonString = "Canvas" 

--create the main canvas
local addon = CreateFrame("FRAME", addonString, WorldMapButton)
addon:RegisterEvent("ADDON_LOADED")
addon:SetPoint("TOPLEFT", WorldMapButton)
addon:SetPoint("BOTTOMRIGHT", WorldMapButton)

addon:EnableMouse(false)
addon:EnableKeyboard(true)

addon:SetScript("OnMouseDown", function(self, mouseButton) self:OnMouseDown(mouseButton) end)
addon:SetScript("OnMouseUp", function(self, mouseButton) self:OnMouseUp(mouseButton) end)
addon:SetScript("OnLeave", function(self, motion) self:OnLeave(motion) end)
addon:SetScript("OnHide", function(self) self:OnHide() end)
addon:SetScript("OnShow", function(self) self:OnShow() end)
addon:SetScript("OnEvent", function(self, event, ...) self:OnEvent(event, ...) end)

addon:Show()

--load library for minimap icons
local HBD = LibStub("HereBeDragons-1.0")
local Pins = LibStub("HereBeDragons-Pins-1.0")

function addon:OnEvent(event, ...)
	if event == "ADDON_LOADED" then
		local name = ...
		if name == addonString then
			self:UnregisterEvent("ADDON_LOADED")
			
			self.applyingTool = false
			self.brushThrottle = 0
			self.throttleReset = {
				["Icon Stamp"] = 0,
				["Paintbrush"] = 0,
				["Eraser"] = 0,
				["Text"] = 0,
				["Title"] = 0,
				["Ping"] = 1,
			}
			self.textureCount = 0
			self.textureCountLoaded = 0
			self.textureCountCap = 10000	--cap per canvas.  points disappear around 16k
			self.newLocation = false
			self.loadingAllowed = false
			self.textureSize = 16
			self.gridSize = 50
			
			
			--info sending control
			--1 cap, 0.1 throttle is 10 points per second
			self.outboundInfo = {}
			self.outboundCap = 1	
			self.outboundThrottle = 0	
			self.outboundThrottleGoal = 0.1
			
			--zone change throttle
			self.zoneChanged = false
			self.zoneThrottle = 0
			self.zoneThrottleGoal = 2
			
			self.brushTip = "Paintbrush"
			self.lastEraser = "Eraser"
			self.lastText = "Text"
			
			--frame levels to build map layers
			self.frameLevel = 0	
			self.frameLevels = {
				WorldMapFrame = self.frameLevel,							--base level
				WorldMapDetailFrame = self.frameLevel + 1,			--blizzard map stuff
				tint = self.frameLevel + 2,											--the tint applied when drawing
				
				line = self.frameLevel + 3,											--lines
				
				WorldMapBlobFrame = self.frameLevel + 5,				--blizzard blobs
				WorldMapButton = self.frameLevel + 6,					--blizzard buttons
				
				title = self.frameLevel + 7,										--titles
				
				WorldMapPOIFrame = self.frameLevel + 8,				--blizzard POI
				
				icon = self.frameLevel + 10,										--icons
				textIcon = self.frameLevel + 11,								--icons with text
				ping = self.frameLevel + 13,										--map pings
				
				WorldMapUnitPositionFrame = self.frameLevel + 50,			--blizzard player icon
				WorldMapPlayerLower = self.frameLevel + 49,
				
				partyMembers = self.frameLevel + 48,						--blizzard party members		
				
				canvasHigh = self.frameLevel + 5000,							--regular canvas, good for most things
				canvasLow = self.frameLevel + 9,								--below icons so they work but can still right click out
				toolbox = self.frameLevel + 100,								--buttons for options
			}
			
			self.eraserLoc = {}
			self.pingList = {}
			self.brushTexture = "Interface\\Addons\\"..addonString.."\\basicBrush.blp"
			self.eraserSize = 15
			self.brushIcon = 3
			self.brushColor = {
				r = 1,
				g = 1,
				b = 1,
			}
			
			self.toolBoxIcons = {
				paintbrush = "Interface\\Addons\\"..addonString.."\\paintbrush.blp",
				eraser = "Interface\\Addons\\"..addonString.."\\eraser.blp",
				icon = "Interface\\Addons\\"..addonString.."\\icon.blp",
				text = "Interface\\Addons\\"..addonString.."\\text.blp",
				title = "Interface\\Addons\\"..addonString.."\\title.blp",
				ping = "Interface\\Addons\\"..addonString.."\\ping.blp",
				share = "Interface\\Addons\\"..addonString.."\\share.blp",
				highLight = "Interface\\Buttons\\CheckButtonHilight.png",
			}
			
			local targetIcons = "Interface\\TARGETINGFRAME\\UI-RaidTargetingIcons"

			self.iconList = {
				[1] = "Interface\\MINIMAP\\TRACKING\\Ammunition",
				[2] = "Interface\\MINIMAP\\TRACKING\\Auctioneer",
				[3] = "Interface\\MINIMAP\\TRACKING\\Banker",
				[4] = "Interface\\MINIMAP\\TRACKING\\BattleMaster",
				[5] = "Interface\\MINIMAP\\TRACKING\\Class",
				[6] = "Interface\\MINIMAP\\TRACKING\\FlightMaster",
				[7] = "Interface\\MINIMAP\\TRACKING\\Food",
				[8] = "Interface\\MINIMAP\\TRACKING\\Innkeeper",
				[9] = "Interface\\MINIMAP\\TRACKING\\Mailbox",
				[10] = "Interface\\MINIMAP\\TRACKING\\None",
				[11] = "Interface\\MINIMAP\\TRACKING\\Poisons",
				[12] = "Interface\\MINIMAP\\TRACKING\\Profession",
				[13] = "Interface\\MINIMAP\\TRACKING\\Reagents",
				[14] = "Interface\\MINIMAP\\TRACKING\\Repair",
				[15] = "Interface\\MINIMAP\\TRACKING\\StableMaster",
				[100] = {texture = targetIcons, dimX = 256, dimY = 256, left = 0, right = 0.25, top = 0, bottom = 0.25, size = 20},
				[101] = {texture = targetIcons, dimX = 256, dimY = 256, left = 0.25, right = 0.5, top = 0, bottom = 0.25, size = 20},
				[102] = {texture = targetIcons, dimX = 256, dimY = 256, left = 0.5, right = 0.75, top = 0, bottom = 0.25, size = 20},
				[103] = {texture = targetIcons, dimX = 256, dimY = 256, left = 0.75, right = 1, top = 0, bottom = 0.25, size = 20},
				[104] = {texture = targetIcons, dimX = 256, dimY = 256, left = 0, right = 0.25, top = 0.25, bottom = 0.5, size = 20},
				[105] = {texture = targetIcons, dimX = 256, dimY = 256, left = 0.25, right = 0.5, top = 0.25, bottom = 0.5, size = 20},
				[106] = {texture = targetIcons, dimX = 256, dimY = 256, left = 0.5, right = 0.75, top = 0.25, bottom = 0.5, size = 20},
				[107] = {texture = targetIcons, dimX = 256, dimY = 256, left = 0.75, right = 1, top = 0.25, bottom = 0.5, size = 20},
			}
			self.lootQuality = {
				[0] = "Poor",
				[1] = "Common",
				[2] = "Uncommon",
				[3] = "Rare",
				[4] = "Epic",
				[5] = "Legendary",
				[6] = "Artifact",
				[7] = "Heirloom",
			}
			
			self.colorNames = {
				[0] = "Poor Grey",
				[1] = "Common White",
				[2] = "Uncommon Green",
				[3] = "Rare Blue",
				[4] = "Epic Purple",
				[5] = "Legendary Orange",
				[6] = "Artifact Gold",
				[7] = "Heirloom Blue",
				["black"] = "Black",
				["WARRIOR"] = "Warrior Brown",
				["MAGE"] = "Mage Blue",
				["ROGUE"] = "Rogue Yellow",
				["DRUID"] = "Druid Orange",
				["HUNTER"] = "Hunter Green",
				["SHAMAN"] = "Shaman Blue",
				["PRIEST"] = "Priest White",
				["WARLOCK"] = "Warlock Lavender",
				["PALADIN"] = "Paladin Pink",
				["DEATHKNIGHT"] = "Death Knight Red",
				["MONK"] = "Monk Jade",
				["DEMONHUNTER"] = "Demon Hunter Purple",
			}
			
			--custom list of continents to fix broken list from GetMapContinents()
			self.continentList = {
				[-1] = "Instances",
				[0] = "Azeroth",
				[1] = "Kalimdor",
				[2] = "Eastern Kingdoms",
				[3] = "Outland",
				[4] = "Northrend",
				[5] = "The Maelstrom",
				[6] = "Pandaria",
				[7] = "Draenor",
				[8] = "Broken Isles"
			}
			
			self.textureList = CANVASDATA or {}

			CANVASSETTINGS = CANVASSETTINGS or {}
			self.settings = CANVASSETTINGS
		
			self.settings.sharePaint = false
			
			self.settings.senderList = self.settings.senderList or {}
			
			self.textures = {}
			self.minimapTextures = {}
					
			self:RegisterEvent("PLAYER_ENTERING_WORLD")
		end
		
	elseif event == "PLAYER_ENTERING_WORLD" then
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self:LoadSetup()

	elseif event == "WORLD_MAP_UPDATE" then
		self:GetCurrentCanvasID()
		
		--"disable" drawing on cosmic map
		if self.contID == -1 and self.areaID == -1 then
			self.Toolbox:Hide()
		else
			if WorldMapFrame:IsVisible() then
				self.Toolbox:Show()
			end
		end
		
		if self.newLocation then
			self:DrawPoints()
			self.zoneChanged = true
			self.zoneThrottle = 0
		end
	
	elseif event == "ZONE_CHANGED" then
		self.zoneChanged = true
		self.zoneThrottle = 0
	
	elseif event == "CHAT_MSG_ADDON" then
	local prefix, message, channel, sender = ...
		--filter other addons
		local playerName = UnitName("player").."-"..GetRealmName()
		if prefix == addonString and sender ~= playerName then
			if not self.settings.senderList[sender] then
				self.settings.senderList[sender] = true
			end
			
			if self.settings.receivePaint then
				if self.settings.senderList[sender] then
					if ( self.settings.receiveLeaderOnly and ( UnitIsRaidOfficer(sender) or UnitIsPartyLeader(sender) ) ) or ( not self.settings.receiveLeaderOnly ) then
						self:AddonComm_Receive(message, sender)
					end
				end
			end
		end
	end
end

function addon:LoadSetup()
	self:LoadAssets()
	self:LoadPaintBuckets()
	self:MiniMapAssets()
	self:ToggleDrawing("hide")
	
	UIPanelWindows["WorldMapFrame"] = nil
	WorldMapFrame:SetFrameStrata("HIGH")
	table.insert(UISpecialFrames, "WorldMapFrame")
	
	WorldMapFrame:Show()
	WorldMapFrame:Hide()

	self:SetScript("OnUpdate", function(self, elapsed) self:ApplyTool(elapsed) end)			
	self.CommFrame:SetScript("OnUpdate", function(_, elapsed) self:CommFrameOnUpdate(elapsed) end)
	
	RegisterAddonMessagePrefix(addonString)
	self:RegisterEvent("CHAT_MSG_ADDON")
	self:RegisterEvent("WORLD_MAP_UPDATE")
	self:RegisterEvent("ZONE_CHANGED")
end

function addon:ClearPoints()
	for point, info in pairs(self.textures) do
		self.textures[point]:Hide()
	end
	self.textureCount = 0
	self.textureCountLoaded = 0
	self.loadingAllowed = false
end

function addon:AllowPoints()
	self:WorldMapFrameLevels()
	self.loadingAllowed = true
	self:DrawPoints()
end

function addon:OnMouseDown(mouseButton)
	if self.Canvas:IsVisible() then
		if mouseButton == "LeftButton" then
			--self.brushThrottle = 1 -- TODO WTF?
			self.applyingTool = true
			self.prevPointX, self.prevPointY = self:GetCurrentCanvasPoint()
		elseif mouseButton == "RightButton" then
			self:ToggleDrawing("hide")
		end
	end
end

function addon:OnMouseUp(mouseButton)
	self:StopDrawing()
end

function addon:OnLeave(motion)
	self:StopDrawing()
end

function addon:OnHide()
	self.loadingAllowed = false
	self.Toolbox:Hide()
	self:ToggleDrawing("hide")
end

function addon:OnShow()
	self.loadingAllowed = true
	self.Toolbox:Show()
	self:WorldMapFrameLevels()
	if not self.hookComplete then
		self:AttachHooks()
	end
end

function addon:AttachHooks()
	--world map frame hooks to handle redrawing
	WorldMapTitleButton:HookScript("OnDragStart", function() self:ClearPoints() end)
	WorldMapTitleButton:HookScript("OnDragStop", function() self:AllowPoints() end)
	
	--map size change
	WorldMapFrameSizeUpButton:HookScript("PreClick", function() self:ClearPoints() end)
	WorldMapFrameSizeUpButton:HookScript("PostClick", function() self:AllowPoints() end)
	
	--map size change
	WorldMapFrameSizeDownButton:HookScript("PreClick", function() self:ClearPoints() end)
	WorldMapFrameSizeDownButton:HookScript("PostClick", function() self:AllowPoints() end)
	
	--quest panel toggle
	WorldMapFrame.UIElementsFrame.CloseQuestPanelButton:HookScript("PreClick", function() self:ClearPoints() end)
	WorldMapFrame.UIElementsFrame.CloseQuestPanelButton:HookScript("PostClick", function() self:AllowPoints() end)
	
	--quest panel toggle
	WorldMapFrame.UIElementsFrame.OpenQuestPanelButton:HookScript("PreClick", function() self:ClearPoints() end)
	WorldMapFrame.UIElementsFrame.OpenQuestPanelButton:HookScript("PostClick", function() self:AllowPoints() end)
	
	--WorldMapButton:HookScript("PreClick", function() self:ClearPoints() end)
	--WorldMapButton:HookScript("PostClick", function() self:AllowPoints() end)
		
	--when you move the map
	WorldMapFrame:HookScript("OnDragStart", function() self:ClearPoints() end)
	WorldMapFrame:HookScript("OnDragStop", function() self:AllowPoints() end)
	
	--when its visibility changes
	WorldMapFrame:HookScript("OnHide", function() self:ClearPoints() end)
	WorldMapFrame:HookScript("OnShow", function() self:AllowPoints() end)
	
	--TODO remove/replace? returns an error when called here. doesnt seem necessary anymore
	--hooksecurefunc("WorldMapFrame_ResetFrameLevels", function() self:WorldMapFrameLevels() end)
	
	--change in map zoom
	
	local origFunc = WorldMapZoomOutButton_OnClick
	function WorldMapZoomOutButton_OnClick(...)
		addon:ClearPoints()
		origFunc(...)
		addon:AllowPoints()
	end
	
	local origFunc2 = WorldMapContinentButton_OnClick
	function WorldMapContinentButton_OnClick(...)
		addon:ClearPoints()
		origFunc2(...)
		addon:AllowPoints()
	end
	
	local origFunc3 = WorldMapZoneButton_OnClick
	function WorldMapZoneButton_OnClick(...)
		addon:ClearPoints()
		origFunc3(...)
		addon:AllowPoints()
	end
	
	--other map mods
	--Mapster
	if MapsterShowOnlyQuestBlobs then
		MapsterShowOnlyQuestBlobs:HookScript("PreClick", function() self:ClearPoints() end)
		MapsterShowOnlyQuestBlobs:HookScript("PostClick", function() self:AllowPoints() end)
	end
	
	--scaling button in bottom right
	if MapsterScaler then	
		--MapsterScaler:HookScript("SetScale", function() self:ClearPoints() print("cleared") end)
		--MapsterScaler:HookScript("OnMouseUp", function() self:AllowPoints() print("drawn") end)
	end
	
	--self:WorldMapFrameLevels()

	--HBD.RegisterCallback(self, "PlayerZoneChanged", function() print("test") end)

	--[[
	local getHeight = Minimap.GetHeight
	Minimap.GetHeight = function()
		local height = getHeight(Minimap)
		return height - 16
	end
	
	local getWidth = Minimap.GetWidth
	Minimap.GetWidth = function()
		local width = getWidth(Minimap)
		return width - 16
	end
	]]
	
	self.hookComplete = true
end

function addon:StopDrawing()
	self.applyingTool = false
	self.prevPointX = nil
	self.prevPointY = nil
end

--apply the tool with tool specific throttle
function addon:ApplyTool(elapsed)
	self.brushThrottle = self.brushThrottle + elapsed
	if self.applyingTool then
		if self.brushThrottle >= self.throttleReset[self.brushTip] then
			self.brushThrottle = 0
			if self.brushTip == "Paintbrush" then
				self:ApplyPaintbrush()
			elseif self.brushTip == "Eraser" then
				self:ApplyEraser()
			elseif self.brushTip == "Icon Stamp" then
				self:ApplyIcon()
			elseif self.brushTip == "Title" then
				self:ApplyTitle()
			elseif self.brushTip == "Ping" then
				self:ApplyPing()
			end
		end
	end
	if self.loadingAllowed and self.textureCountLoaded < self.textureCount then
		self:ThrottleDisplay()
	end
end

--throttle sending of points to clients to avoid destroying your outbound bandwidth
function addon:CommFrameOnUpdate(elapsed)
	--outbound comm throttling so you dont overload pipe
	self.outboundThrottle = self.outboundThrottle + elapsed
	if self.outboundThrottle >= self.outboundThrottleGoal and #self.outboundInfo > 0 then
		self.outboundThrottle = 0
		self:ThrottleAddonComms()
	end
	
	--control amount of minimap updates based off zone changes
	self.zoneThrottle = self.zoneThrottle + elapsed
	if self.zoneChanged then
		if self.zoneThrottle >= self.zoneThrottleGoal then
			self.zoneChanged = false
			self.zoneThrottle = 0
			
			self:UpdateMinimapPoints()
		end
	end
end
--map area/level exists in table
function addon:AreaExists(contID, areaID, floorID)
	if self.textureList[contID] then
		if self.textureList[contID][areaID] then
			if self.textureList[contID][areaID][floorID] then
				return true
			end
		end
	end
	
	return false
end

--area/level is the current map
function addon:AreaConfirm(contID, areaID, floorID)
	if contID == self.contID and areaID == self.areaID and floorID == self.floorID then
		return true
	end
	
	return false
end

--draw initial data onto canvas
function addon:DrawPoints()
	for point, info in pairs(self.textures) do
		self.textures[point]:Hide()
	end
	self.textureCount = 0
	self.textureCountLoaded = 0	
		
	if self:AreaExists(self.contID, self.areaID, self.floorID) then
		local id = 1
		for _, grid in pairs(self.textureList[self.contID][self.areaID][self.floorID]) do
			if type(grid) == "table" then
				for point, info in pairs(grid) do
					info.id = id
					self:DrawPoint(id, info)
				
					self.textureCount = id
					--up the count for the current canvas
					self.textureList[self.contID][self.areaID][self.floorID].count = id
					id = id + 1
				end
			end
		end
	end
	
	self.newLocation = false
end

--draw points to the canvas at a controlled rate to stop large freezing issues
function addon:ThrottleDisplay()
	local loadGoal = self.textureCountLoaded + 200
	local startPoint = self.textureCountLoaded + 1
	if loadGoal > self.textureCount then
		loadGoal = self.textureCount
	end
	
	for id = startPoint, loadGoal do
		if self.textures[id] then
			self.textures[id]:Show()
		end
	end
	self.textureCountLoaded = loadGoal
end

--send a packet of points
function addon:ThrottleAddonComms()
	local loadGoal = self.outboundCap
	for id, info in pairs(self.outboundInfo) do
		ChatThrottleLib:SendAddonMessage("NORMAL", addonString, info.message, info.channel, info.target or nil)
		table.remove(self.outboundInfo, id)
		
		loadGoal = loadGoal - 1
		if loadGoal <= 0 then
			return true
		end
	end
end

--draw a single point using the given id
function addon:DrawPoint(id, info)
	if not self.textures[id] then
		local frame
		frame = CreateFrame("FRAME", nil, self)
		self.textures[id] = frame
		frame.icon = frame:CreateTexture("Icon", nil, nil, 1)
		frame.icon:SetPoint("CENTER")
		frame:SetWidth(32)
		frame:SetHeight(32)
		frame:SetID(id)
		frame.text = frame:CreateFontString("Text")
		frame.text:SetFontObject("ZoneTextFont")
		frame.text:SetPoint("BOTTOM", frame, "CENTER", 0, -5)
		frame:EnableMouse(false)
		frame:SetScript("OnUpdate", function(frame) self:Texture_OnUpdate(frame) end)
		frame:SetScript("OnMouseUp", function(frame) self:Texture_OnClick(frame) end)
		frame:SetScript("OnEnter", function(frame) self:Texture_OnEnter(frame) end)
		frame:SetScript("OnLeave", function() GameTooltip:Hide() end)
	end
	local frame = self.textures[id]
	
	frame:SetPoint("CENTER", self.Canvas, "BOTTOMLEFT", info.x, info.y)
	frame.x = info.x
	frame.y = info.y
	
	--SETUP DEFAULTS HERE THEN APPLY STUFF DEPENDING ON INFO
	frame:SetFrameLevel(self.frameLevels.line)
	
	frame:SetAlpha(0.7)
	frame.icon:SetTexture(self.brushTexture)
	frame.icon:SetWidth(self.textureSize)
	frame.icon:SetHeight(self.textureSize)
	frame.icon:Show()
	
	frame.textString = nil
	frame.text:SetText("")
	frame.mouseEnable = true
	frame.text:Hide()
	
	if frame.ping then
		frame.ping:Hide()
	end
	
	--rotate it right
	if info.rotation then
		frame.icon:SetRotation(info.rotation)
	else
		frame.icon:SetRotation(0)
	end
	
	--apply any color
	if info.r and info.g and info.b then
		frame.icon:SetVertexColor(info.r, info.g, info.b, 1)
	end
	
	--is an icon
	if info.iconID then
		frame:SetFrameLevel(self.frameLevels.icon)
		frame:SetAlpha(1)
		if type(self.iconList[info.iconID]) == "table" then
			frame.icon:SetTexture(self.iconList[info.iconID].texture)
			frame.icon:SetTexCoord(self.iconList[info.iconID].left, self.iconList[info.iconID].right, self.iconList[info.iconID].top, self.iconList[info.iconID].bottom)
			frame.icon:SetWidth(self.iconList[info.iconID].size)
			frame.icon:SetHeight(self.iconList[info.iconID].size)
		else
			frame.icon:SetTexture(self.iconList[info.iconID])
			frame.icon:SetTexCoord(0, 1, 0, 1)
			frame.icon:SetWidth(24)
			frame.icon:SetHeight(24)
		end
		frame.icon:SetVertexColor(1, 1, 1, 1)
		frame.icon:Show()
		frame.mouseEnable = true
		frame.text:Hide()
	end
	
	--icon has tooltip
	if info.text then
		frame:SetFrameLevel(self.frameLevels.textIcon)
		frame.textString = info.text
	end
	
	--is a title
	if info.title then
		frame:SetAlpha(1)
		frame:SetFrameLevel(self.frameLevels.title)
		frame.text:SetText(info.title)
		frame.icon:Hide()
		frame.text:Show()
	end
	
	--is a map ping
	if info.ping then
		frame:SetFrameLevel(self.frameLevels.ping)
		frame.icon:Hide()
		if not frame.ping then
			self:CreatePingAnim(frame)
		end
		frame.ping:Show()
		frame.ping.pingRing.anim:Play()
		frame.ping.pingAim.anim:Play()
	end
	
	--apply time stamp if none exists
	if not info.timeID then
		info.timeID = time()
	end
	
	frame:Hide()
end

--create a ping animation on a point
function addon:CreatePingAnim(frame)
	local pingDot = "Interface\\MINIMAP\\Ping\\ping2"
	local pingRing = "Interface\\MINIMAP\\Ping\\ping4"
	local pingAim = "Interface\\MINIMAP\\Ping\\ping5"
	
	frame.ping = CreateFrame("FRAME", nil, frame)
	frame.ping:SetSize(32, 32)
	frame.ping:SetPoint("CENTER")
	
	frame.ping.pingDot = frame.ping:CreateTexture()
	frame.ping.pingDot:SetTexture(pingDot)
	frame.ping.pingDot:SetAllPoints()
	frame.ping.pingDot:SetBlendMode("ADD")
	
	frame.ping.pingRing = frame.ping:CreateTexture()
	frame.ping.pingRing:SetTexture(pingRing)
	frame.ping.pingRing:SetSize(1, 1)
	frame.ping.pingRing:SetPoint("CENTER")	
	frame.ping.pingRing:SetBlendMode("ADD")
	
	frame.ping.pingAim = frame.ping:CreateTexture()
	frame.ping.pingAim:SetTexture(pingAim)
	frame.ping.pingAim:SetAllPoints()
	frame.ping.pingAim:SetBlendMode("ADD")
	
	local function finishAnim(frame)
		frame.ping.pingRing.anim:Stop()
		frame.ping:Hide()

		if self:AreaExists(self.contID, self.areaID, self.floorID) then
			local gridID = self:GetGridLocation(frame.x, frame.y)
			self:CreateGrid(self.textureList[self.contID][self.areaID][self.floorID], gridID)
			for point, info in pairs(self.textureList[self.contID][self.areaID][self.floorID][gridID]) do
				if info.id == frame:GetID() then
					table.remove(self.textureList[self.contID][self.areaID][self.floorID][gridID], point)
					return true
				end
			end
		end
	end

	--scaling pulse
	frame.ping.pingRing.anim = frame.ping.pingRing:CreateAnimationGroup()
	frame.ping.pingRing.a1 = frame.ping.pingRing.anim:CreateAnimation("Scale")	
	frame.ping.pingRing.a1:SetDuration(0.7)
	frame.ping.pingRing.a1:SetScale(50, 50)
	frame.ping.pingRing.a1:SetOrder(1)
	frame.ping.pingRing.anim:SetLooping("REPEAT")
	
	--rotation of ping
	frame.ping.pingAim.anim = frame.ping.pingAim:CreateAnimationGroup()
	
	frame.ping.pingAim.a1 = frame.ping.pingAim.anim:CreateAnimation("Rotation")
	frame.ping.pingAim.a1:SetDuration(6)
	frame.ping.pingAim.a1:SetDegrees(-1080)
	frame.ping.pingAim.a1:SetOrder(1)
	frame.ping.pingAim.anim:SetScript("OnFinished", function() finishAnim(frame) end)
	
	frame.ping:Show()
	frame.ping.pingRing.anim:Play()
	frame.ping.pingAim.anim:Play()
end

--apply paintbrush to canvas, draw line
function addon:ApplyPaintbrush()
	local canvasX, canvasY = self:GetCurrentCanvasPoint()
	
	local dX = canvasX - self.prevPointX
	local dY = canvasY - self.prevPointY	
	local hyp = math.sqrt( dX ^ 2 + dY ^ 2 )
	local pixelSize = self.textureSize / 2.85
	local segments = math.ceil(hyp / pixelSize)
	if segments > 0 then
		self:DrawLine(self.prevPointX, self.prevPointY, canvasX, canvasY, self.brushColor.r, self.brushColor.g, self.brushColor.b, self.contID, self.areaID, self.floorID)
			
		if self.settings.sharePaint then
			local message = {
				[1] = "line",
				[2] = self.contID,
				[3] = self.areaID,
				[4] = self.floorID,
				[5] = self.prevPointX,
				[6] = self.prevPointY,
				[7] = canvasX,
				[8] = canvasY,
				[9] = self.brushColor.r,
				[10] = self.brushColor.g,
				[11] = self.brushColor.b,		
			}
			self:AddonComm_Send(message, "PARTY")
		end
		
		self.prevPointX = canvasX
		self.prevPointY = canvasY
	end
end

--draw line between 2 points
function addon:DrawLine(x1, y1, x2, y2, r, g, b, contID, areaID, floorID, artist)
	local dX = x2 - x1
	local dY = y2 - y1
	
	local hyp = math.sqrt( dX ^ 2 + dY ^ 2 )
	local pixelSize = self.textureSize / 3	--2.85
	local segments = math.ceil(hyp / pixelSize)
	local rotation = math.round(math.atan2(dY, dX), 2)
	for j = 0, segments - 1 do
		--make each texture that creates the line between the 2 points
		local x = math.round(x1 + math.cos(rotation) * pixelSize * j, 0)
		local y = math.round(y1 + math.sin(rotation) * pixelSize * j, 0)
		local id = self.textureCount + 1
		--save texture point into list
		local info = {
			rotation = rotation,
			id = id,
			x = x,
			y = y,
			r = r,
			b = b,
			g = g,
			artist = artist,
		}
		
		self:CreateCanvas(contID, areaID, floorID)
		if self:CanvasPointIncrement(self.textureList[contID][areaID][floorID]) then
			local gridID = self:GetGridLocation(x, y)
			self:CreateGrid(self.textureList[contID][areaID][floorID], gridID)
			table.insert(self.textureList[contID][areaID][floorID][gridID], info)
		
			if self:AreaConfirm(contID, areaID, floorID) then
				self.textureCount = self.textureCount + 1
				self:DrawPoint(self.textureCount, info)
			end
		end
	end
end

--apply icon to canvas, draw icon
function addon:ApplyIcon()
	local canvasX, canvasY = self:GetCurrentCanvasPoint()
	local iconID = self.brushIcon
	local uniqueID = GetTime()
	
	self:DrawIcon(canvasX, canvasY, iconID, nil, self.contID, self.areaID, self.floorID, uniqueID)
	
	if self.settings.sharePaint then
		local message = {
			[1] = "icon",
			[2] = self.contID,
			[3] = self.areaID,
			[4] = self.floorID,
			[5] = canvasX,
			[6] = canvasY,
			[7] = iconID,
			[8] = uniqueID
		}
		self:AddonComm_Send(message, "PARTY")
	end
	
	self:StopDrawing()
end

--draw an icon at a point
function addon:DrawIcon(x, y, iconID, text, contID, areaID, floorID, uniqueID, artist)
	local id = self.textureCount + 1
	
	local info = {
		x = x,
		y = y,
		id = id,
		iconID = iconID,
		text = text,
		artist = artist,
		uniqueID = uniqueID
	}
	
	self:CreateCanvas(contID, areaID, floorID)		
	if self:CanvasPointIncrement(self.textureList[contID][areaID][floorID]) then
		local gridID = self:GetGridLocation(x, y)
		self:CreateGrid(self.textureList[contID][areaID][floorID], gridID)
		table.insert(self.textureList[contID][areaID][floorID][gridID], info)
		
		if self:AreaConfirm(contID, areaID, floorID) then
			self.textureCount = self.textureCount + 1
			self:DrawPoint(self.textureCount, info)
		end
	end
end

--use text to icon tool
function addon:ApplyText(frame)
	if self:AreaExists(self.contID, self.areaID, self.floorID) then
		local searching = true
		local frameID = frame:GetID()
		local gridID = self:GetGridLocation(frame.x, frame.y)
		for point, info in pairs(self.textureList[self.contID][self.areaID][self.floorID][gridID]) do
			if searching then
				if type(info) == "table" then
					if info.id == frameID then
						--prepare/cancel input box if it was open
						self:TextInput_OnEscapePressed()
						
						function textFunc(info)
							info.text = self.TextInput:GetText()
							
							self:DrawPoint(info.id, info)
							self.textures[info.id]:Show()
											
							if self.settings.sharePaint then
								local message = {
									[1] = "text",
									[2] = self.contID,
									[3] = self.areaID,
									[4] = self.floorID,
									[5] = info.text,
									[6] = info.uniqueID,
									[7] = frame.x,
									[8] = frame.y,
								}
								self:AddonComm_Send(message, "PARTY")
							end
						end
						
						self.TextInput:SetPoint("LEFT", self.textures[info.id], "RIGHT", 10, 0)
						self:TextEditor_Prep(info, textFunc)
						searching = false
					end
				end
			else
				return
			end
		end
	end
end

--use title tool
function addon:ApplyTitle()
	local canvasX, canvasY = self:GetCurrentCanvasPoint()
	local info = {}
	
	local function titleFunc(info)
		info.title = self.TextInput:GetText()
		self:AddTitle(canvasX, canvasY, self.contID, self.areaID, self.floorID, info.title)
		
		if self.settings.sharePaint then
			local message = {
				[1] = "title",
				[2] = self.contID,
				[3] = self.areaID,
				[4] = self.floorID,
				[5] = canvasX,
				[6] = canvasY,
				[7] = info.title,
			}
			self:AddonComm_Send(message, "PARTY")
		end
	end

	--prepare/cancel input box if it was open
	self:TextInput_OnEscapePressed()
	local cursorX, cursorY = GetCursorPosition()
	self.TextInput:SetPoint("LEFT", UIParent, "BOTTOMLEFT", (cursorX + 10) / UIParent:GetEffectiveScale(), cursorY / UIParent:GetEffectiveScale())
	self:TextEditor_Prep(info, titleFunc)
	
	self:StopDrawing()
end

--add a title to the location
function addon:AddTitle(x, y, contID, areaID, floorID, title, artist)
	local id = self.textureCount + 1
	
	local info = {
		x = x,
		y = y,
		id = id,
		title = title,
		artist = artist,
	}
	
	self:CreateCanvas(contID, areaID, floorID)	
	if self:CanvasPointIncrement(self.textureList[contID][areaID][floorID]) then
		local gridID = self:GetGridLocation(x, y)
		self:CreateGrid(self.textureList[contID][areaID][floorID], gridID)
		table.insert(self.textureList[contID][areaID][floorID][gridID], info)
		
		if self:AreaConfirm(contID, areaID, floorID) then
			self.textureCount = self.textureCount + 1
			self:DrawPoint(self.textureCount, info)
		end
	end
end

--supply editor with info
function addon:TextEditor_Prep(info, enterFunc)
	if info.text then
		self.TextInput:SetText(info.text)
	else
		self.TextInput:SetText("")
	end
	self.TextInput.info = info
	self.TextInput.enterFunc = enterFunc
	self.TextInput:Show()
end

--show the text editor
function addon:TextInput_OnShow()
	self.TextInput:SetFocus()	
end

--grab text from editor and apply it
function addon:TextInput_OnEnterPressed()	
	local info = self.TextInput.info	
	self.TextInput.enterFunc(info)
	
	self:TextInput_OnEscapePressed()
end

--clear the editor and reset it
function addon:TextInput_OnEscapePressed()
	self.TextInput.info = nil
	self.TextInput.enterFunc = nil
	self.TextInput:ClearFocus()
	self.TextInput:Hide()
end

--make sure its visible when it should be
function addon:TextInput_OnUpdate()
	if self.Canvas:IsVisible() then
		if not ( self.brushTip == "Text" or self.brushTip == "Title" ) then
			self:TextInput_OnEscapePressed()
		end
	else
		self:TextInput_OnEscapePressed()
	end
end

--use the eraser tool
function addon:ApplyEraser()
	local canvasX, canvasY = self:GetCurrentCanvasPoint()
	local timeID = time()
	
	self:EraseLocation(canvasX, canvasY, self.eraserSize, self.contID, self.areaID, self.floorID, timeID)
end

--erase a location
function addon:EraseLocation(x, y, eraserSize, contID, areaID, floorID, timeID, artist)
	if self:AreaExists(contID, areaID, floorID) then
		local somethingErased = false
		local centerGrid = self:GetGridLocation(x, y)
		local affectedGrids = self:SurroundingGrids(centerGrid)
		for _, gridID in pairs(affectedGrids) do
			if self.textureList[contID][areaID][floorID][gridID] then
				for point, info in pairs(self.textureList[contID][areaID][floorID][gridID]) do
					if type(info) == "table" then
						local distX = math.abs(x - info.x)
						local distY = math.abs(y - info.y)
						
						--if there is no time stamp to avoid error
						if not info.timeID then info.timeID = time() end
						
						if distX <= eraserSize and distY <= eraserSize and info.timeID <= timeID then
							local eraseFlag = true
							--TODO working eraser for your own stuff only..
							-- if info.artist then
								-- eraseFlag = false
								-- if info.artist == artist or info.artist == UnitName("player") then	--either someone else is trying to erase their own stuff or you managed to receive something from yourself and are trying to erase it
									-- eraseFlag = true
								-- end
							-- end
							
							if eraseFlag then
								somethingErased = true
								self.textureList[contID][areaID][floorID][gridID][point] = nil
								self:CanvasPointDecrement(self.textureList[contID][areaID][floorID])
														
								if self:AreaConfirm(contID, areaID, floorID) then
									self.textures[info.id]:Hide()
								end
							end
						end
					end
				end
			end
		end
		
		self:CleanTable(contID, areaID, floorID)
		
		--dont share if this location itself was shared
		if somethingErased and not artist then
			if self.settings.sharePaint then
				local message = {
					[1] = "erase",
					[2] = contID,
					[3] = areaID,
					[4] = floorID,
					[5] = x,
					[6] = y,
					[7] = eraserSize,
				}
				self:AddonComm_Send(message, "PARTY")
			end
		end
	end
end

--ping a location on the canvas
function addon:ApplyPing()
	local canvasX, canvasY = self:GetCurrentCanvasPoint()
	
	self:AddPing(canvasX, canvasY, self.contID, self.areaID, self.floorID)
	
	if self.settings.sharePaint then
		local message = {
			[1] = "ping",
			[2] = self.contID,
			[3] = self.areaID,
			[4] = self.floorID,
			[5] = canvasX,
			[6] = canvasY,
		}
		self:AddonComm_Send(message, "PARTY")
	end
	
	self:StopDrawing()
end

--actually animate the ping on the map
function addon:AddPing(x, y, contID, areaID, floorID, artist)
	local id = self.textureCount + 1
	
	local info = {
		x = x,
		y = y,
		id = id,
		ping = 1,
		artist = artist,
	}
	
	self:CreateCanvas(contID, areaID, floorID)
	local gridID = self:GetGridLocation(x, y)
	self:CreateGrid(self.textureList[contID][areaID][floorID], gridID)
	table.insert(self.textureList[contID][areaID][floorID][gridID], info)
		
	if self:AreaConfirm(contID, areaID, floorID) then
		self.textureCount = self.textureCount + 1
		self:DrawPoint(self.textureCount, info)
	end
end

--rounding function
function math.round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

--erase a specific canvas
function addon:EraseCanvas(contID, areaID, floorID)
	if self:AreaExists(contID, areaID, floorID) then
		self.textureList[contID][areaID][floorID] = nil
		
		self:CleanTable(contID, areaID, floorID)
		
		self:DrawPoints()
	end
end

--erase all canvases
function addon:EraseAllCanvas()
	for contID in pairs(self.textureList) do
		self.textureList[contID] = nil
	end
	self:DrawPoints()
end

--return mouse coordinates coordinates relative to canvas for location purposes
function addon:GetCurrentCanvasPoint()
	local edgeSize = self.eraserSize
	local cursorX, cursorY = GetCursorPosition()
	local frameX, frameY = self:GetLeft(), self:GetBottom()
	local x = (cursorX / self:GetEffectiveScale()) - frameX
	local y = (cursorY / self:GetEffectiveScale()) - frameY
	
	--too left
	if x < edgeSize then
		x = edgeSize
	end
	
	--too right
	if x > self:GetWidth() - edgeSize then
		x = self:GetWidth() - edgeSize
	end
	
	--too low
	if y < edgeSize then
		y = edgeSize
	end
	
	--too high
	if y > self:GetHeight() - edgeSize then
		y = self:GetHeight() - edgeSize
	end
	
	return math.floor(x), math.floor(y)
end

--canvas ids
function addon:GetCurrentCanvasID()
	self.newLocation = false
	self.oldContID = self.contID
	self.oldAreaID = self.areaID
	self.oldFloorID = self.floorID
	
	self.contID = GetCurrentMapContinent()
	self.areaID = GetCurrentMapAreaID()
	self.floorID = GetCurrentMapDungeonLevel()
	
	if self.contID ~= self.oldContID or self.areaID ~= self.oldAreaID or self.floorID ~= self.oldFloorID then
		self.newLocation = true
	end
end

--setup frame levels to the appropriate level so it layers nicely
function addon:WorldMapFrameLevels()
	WorldMapFrame:SetToplevel(false)
	WorldMapFrame:SetFrameStrata("HIGH")
	WorldMapUnitPositionFrame:SetFrameStrata("HIGH")
	--WorldMapPlayerLower:SetFrameStrata("HIGH")
	self:SetFrameStrata("HIGH")
	self.BrushGraphic:SetFrameStrata("DIALOG")
	
	self.frameLevel = WorldMapFrame:GetFrameLevel()
		
	WorldMapFrame:SetFrameLevel(self.frameLevels.WorldMapFrame)				--bottom
	WorldMapDetailFrame:SetFrameLevel(self.frameLevels.WorldMapDetailFrame)		--the textures for the map itself
	self.Canvas:SetFrameLevel(self.frameLevels.tint)					--my canvas (tinted when drawing)
	--lines go here
	WorldMapBlobFrame:SetFrameLevel(self.frameLevels.WorldMapBlobFrame)		--the quest blob things
	WorldMapButton:SetFrameLevel(self.frameLevels.WorldMapButton)			--the button for switching maps
	--titles go here
	WorldMapPOIFrame:SetFrameLevel(self.frameLevels.WorldMapPOIFrame)				--POI's on map
	self.LowerCanvas:SetFrameLevel(self.frameLevels.canvasLow)									--lower canvas for collecting clicks when editting icon text
	--there are a couple POI things at +1 and +2
	--icons and text go here
	WorldMapUnitPositionFrame:SetFrameLevel(self.frameLevels.WorldMapUnitPositionFrame)		--players arrow
	--WorldMapPlayerLower:SetFrameLevel(self.frameLevels.WorldMapPlayerLower)	--that ping thingy i think
    --for i=1, MAX_PARTY_MEMBERS do
    --    _G["WorldMapParty"..i]:SetFrameLevel(self.frameLevels.partyMembers)	--party members dots
   -- end
    
    --for i=1, MAX_RAID_MEMBERS do
   --     _G["WorldMapRaid"..i]:SetFrameLevel(self.frameLevels.partyMembers)	--raid members dots
    --end

	--self:SetFrameLevel(self.frameLevels.canvasHigh)	--handles in onupdate based on brush choice
	self.Toolbox:SetFrameLevel(self.frameLevels.toolbox)
	self:SetFrameLevel(self.frameLevels.canvasHigh)
	WorldMapTooltip:SetFrameStrata("TOOLTIP")
end

--maintain brush graphic based on tool being used
function addon:BrushDisplay()
	local canvasX, canvasY = self:GetCurrentCanvasPoint()
	self:GetCurrentCanvasID()
	
	self.BrushGraphic:SetPoint("CENTER", self, "BOTTOMLEFT", canvasX, canvasY)
		
	self.BrushGraphic.Icon:Hide()
	self.BrushGraphic.Eraser:Hide()
	self.BrushGraphic:Hide()
   		
	if self.Canvas:IsVisible() then
		self:EnableMouse(true)
		if self.brushTip == "Paintbrush" then
			
		elseif self.brushTip == "Eraser" then
			self.BrushGraphic.Eraser:Show()
			self.BrushGraphic:Show()
		
		elseif self.brushTip == "Icon Stamp" then
			local icon = self.iconList[self.brushIcon]
			if type(icon) == "table" then
				self.BrushGraphic.Icon:SetTexture(icon.texture)
				self.BrushGraphic.Icon:SetTexCoord(icon.left, icon.right, icon.top, icon.bottom)
				self.BrushGraphic.Icon:SetWidth(icon.size)
				self.BrushGraphic.Icon:SetHeight(icon.size)
			else
				self.BrushGraphic.Icon:SetTexture(icon)
				self.BrushGraphic.Icon:SetTexCoord(0, 1, 0, 1)
				self.BrushGraphic.Icon:SetWidth(24)
				self.BrushGraphic.Icon:SetHeight(24)
			end
			self.BrushGraphic.Icon:Show()
			self.BrushGraphic:Show()
		
		elseif self.brushTip == "Text" then
			self:EnableMouse(false)
		
		elseif self.brushTip == "Title" then

			
		else
			self.BrushGraphic:Hide()
		end
	else
		self.BrushGraphic:Hide()
		self:EnableMouse(false)
	end
end

--[[

FRAME CREATION

]]

function addon:LoadAssets()
	--canvas background
	local frame = CreateFrame("FRAME", addonString.."_Surface", WorldMapButton)
	self.Canvas = frame
	frame:SetPoint("TOPLEFT", self, "TOPLEFT")
	frame:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT")
	frame:Hide()
	
	local texture = frame:CreateTexture(addonString.."Background", "BACKGROUND") 
	texture:SetAllPoints()
	texture:SetColorTexture(0, 0, 0, 0.3)
	
	--secondary frame to capture mouse clicks when editting icons text
	frame = CreateFrame("FRAME", addonString.."_Surface2", WorldMapButton)
	self.LowerCanvas = frame
	frame:SetPoint("TOPLEFT", self, "TOPLEFT")
	frame:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT")
	frame:EnableMouse(true)
	frame:SetScript("OnMouseDown", function(button, mouseButton) self:OnMouseDown(mouseButton) end)
	frame:Hide()

	--always "visible" frame that will continue to communicate info after hiding map
	frame = CreateFrame("FRAME", addonString.."_Communication", UIParent)
	self.CommFrame = frame
	frame:SetPoint("TOPLEFT", UIParent)
	
	--brush display
	frame = CreateFrame("FRAME", addonString.."_BrushGraphic", self)
	self.BrushGraphic = frame
	frame:SetSize(self.eraserSize * 2, self.eraserSize * 2)
	frame:SetPoint("CENTER")
	frame:SetFrameStrata("DIALOG")
	frame:Hide()
	
	--eraser
	frame = CreateFrame("FRAME", nil, self.BrushGraphic)
	self.BrushGraphic.Eraser = frame
	frame:SetBackdrop({
		bgFile="Interface\\CHATFRAME\\CHATFRAMEBACKGROUND", 
		edgeFile="Interface\\CHATFRAME\\CHATFRAMEBACKGROUND", 
		tile=1, tileSize=10, edgeSize=1, 
		insets={left=0, right=0, top=0, bottom=0}
	})
	frame:SetBackdropColor(1, 1, 1, 0.5)
	frame:SetBackdropBorderColor(0, 0, 0, 1)
	frame:SetAllPoints()
	frame:Hide()
	
	--icon display
	texture = self.BrushGraphic:CreateTexture()
	self.BrushGraphic.Icon = texture
	texture:SetPoint("CENTER")
	texture:SetSize(32 * self:GetEffectiveScale(), 32 * self:GetEffectiveScale())
	texture:Hide()
	
	--text editor box
	frame = CreateFrame("EDITBOX", nil, UIParent, "InputBoxTemplate")
	self.TextInput = frame
	frame:SetAutoFocus(false)
	frame:SetScript("OnEscapePressed", function() self:TextInput_OnEscapePressed() end)
	frame:SetScript("OnEnterPressed", function() self:TextInput_OnEnterPressed() end)
	frame:SetScript("OnShow", function() self:TextInput_OnShow() end)
	frame:SetScript("OnUpdate", function() self:TextInput_OnUpdate() end)	
	frame:SetFrameStrata("DIALOG")
	frame:SetMaxLetters(150)
	local _, fontHeight, _ = frame:GetFont()
	frame:SetSize(250, fontHeight)
	frame:SetJustifyV("TOP")
	frame:SetJustifyH("LEFT")
	frame:Hide()
	
	button = CreateFrame("BUTTON", nil, self.TextInput, "UIPanelButtonTemplate")
	self.TextInput.ShiftLeft = button
	button:SetWidth(16)
	button:SetHeight(16)
	button:SetText("<")
	button:SetPoint("TOPLEFT", frame, "BOTTOMLEFT", 0, -4)
	button:SetScript("OnClick", function() self.TextInput:SetCursorPosition(0) self.TextInput:HighlightText(0, 0) end)
	
	button = CreateFrame("BUTTON", nil, self.TextInput, "UIPanelButtonTemplate")
	self.TextInput.SelectAll = button
	button:SetWidth(16)
	button:SetHeight(16)
	button:SetText("[ ]")
	button:SetPoint("LEFT", self.TextInput.ShiftLeft, "RIGHT", 2, 0)
	button:SetScript("OnClick", function() self.TextInput:HighlightText() end)
	
	button = CreateFrame("BUTTON", nil, self.TextInput, "UIPanelButtonTemplate")
	self.TextInput.ShiftRight = button
	button:SetWidth(16)
	button:SetHeight(16)
	button:SetText(">")
	button:SetPoint("LEFT", self.TextInput.SelectAll, "RIGHT", 2, 0)
	button:SetScript("OnClick", function() self.TextInput:HighlightText(0, 0) self.TextInput:SetCursorPosition(self.TextInput:GetNumLetters()) end)
	
	button = CreateFrame("BUTTON", nil, self.TextInput, "UIPanelButtonTemplate")
	self.TextInput.Cancel = button
	button:SetWidth(16)
	button:SetHeight(16)
	button:SetText("X")
	button:SetPoint("TOPRIGHT", self.TextInput, "BOTTOMRIGHT", 0, -4)
	button:SetScript("OnClick", function() self:TextInput_OnEscapePressed() end)
	
	--toolbox frame
	frame = CreateFrame("FRAME", addonString.."_Toolbox", UIParent)
	self.Toolbox = frame
	frame:SetPoint("BOTTOMLEFT", WorldMapFrame, "BOTTOMLEFT", 2, 2)
	frame:SetSize(90, 148)
	frame:EnableMouse(true)
	frame:SetFrameStrata("HIGH")
	frame:SetScript("OnUpdate", function() self:BrushDisplay() end)
	frame:Hide()
	
	--paintbrush toolbox
	local dropDown = CreateFrame("FRAME")
	self.PaintbrushDropdown = dropDown
	dropDown.displayMode = "MENU"
	dropDown.initialize = function(dropDown, level) self:Toolbox_Initialization_Paintbrush(dropDown, level) end
	dropDown:Hide()
	
	local button = CreateFrame("BUTTON", nil, self.Toolbox)
	self.PaintbrushButton = button
	button:SetWidth(24)
	button:SetHeight(24)
	button:SetNormalTexture(self.toolBoxIcons.paintbrush)
	button:SetHighlightTexture(self.toolBoxIcons.highLight)
	--button:SetFrameLevel(button:GetParent():GetFrameLevel() + 1)
	button:SetPoint("TOPLEFT", self.Toolbox, "TOPLEFT", 2, -2)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetScript("OnClick", function(frame, mouseButton)
		self.brushTip = "Paintbrush"
		self:ToggleDrawing("draw")
		if mouseButton == "RightButton" then
			ToggleDropDownMenu(1, nil, self.PaintbrushDropdown, self.PaintbrushButton, frame:GetWidth(), frame:GetHeight())
			GameTooltip:Hide()
		end
	end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Paintbrush") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	--eraser toolbox
	dropDown = CreateFrame("FRAME")
	self.EraserDropdown = dropDown
	dropDown.displayMode = "MENU"
	dropDown.initialize = function(dropDown, level) self:Toolbox_Initialization_Eraser(dropDown, level) end
	dropDown:Hide()
	
	button = CreateFrame("BUTTON", nil, self.Toolbox)
	self.EraserButton = button
	button:SetWidth(24)
	button:SetHeight(24)
	button:SetNormalTexture(self.toolBoxIcons.eraser)
	button:SetHighlightTexture(self.toolBoxIcons.highLight)
	--button:SetFrameLevel(button:GetParent():GetFrameLevel() + 1)
	button:SetPoint("TOP", self.PaintbrushButton, "BOTTOM", 0, -2)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetScript("OnClick", function(frame, mouseButton)
		self.brushTip = "Eraser"
		self:ToggleDrawing("draw")
		if mouseButton == "RightButton" then
			ToggleDropDownMenu(1, nil, self.EraserDropdown, self.EraserButton, frame:GetWidth(), frame:GetHeight())
			GameTooltip:Hide()
		end
	end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Eraser") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	--ping toolbox	
	button = CreateFrame("BUTTON", nil, self.Toolbox)
	self.PingButton = button
	button:SetWidth(24)
	button:SetHeight(24)
	button:SetNormalTexture(self.toolBoxIcons.ping)
	button:SetHighlightTexture("Interface\\Buttons\\CheckButtonHilight.png")
	--button:SetFrameLevel(button:GetParent():GetFrameLevel() + 1)
	button:SetPoint("LEFT", self.EraserButton, "RIGHT", 2, 0)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetScript("OnClick", function(frame, mouseButton)
		self.brushTip = "Ping"
		self:ToggleDrawing("draw")
	end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Ping Map") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	--icon toolbox
	dropDown = CreateFrame("FRAME")
	self.IconDropdown = dropDown
	dropDown.displayMode = "MENU"
	dropDown.initialize = function(dropDown, level) self:Toolbox_Initialization_Icon(dropDown, level) end
	dropDown:Hide()
	
	button = CreateFrame("BUTTON", nil, self.Toolbox)
	self.IconButton = button
	button:SetWidth(24)
	button:SetHeight(24)
	button:SetNormalTexture(self.toolBoxIcons.icon)
	button:SetHighlightTexture(self.toolBoxIcons.highLight)
	--button:SetFrameLevel(button:GetParent():GetFrameLevel() + 1)
	button:SetPoint("LEFT", self.PaintbrushButton, "RIGHT", 2, 0)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetScript("OnClick", function(frame, mouseButton)
		self.brushTip = "Icon Stamp"
		self:ToggleDrawing("draw")
		if mouseButton == "RightButton" then
			ToggleDropDownMenu(1, nil, self.IconDropdown, self.IconButton, frame:GetWidth(), frame:GetHeight())
			GameTooltip:Hide()
		end
	end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Icon Stamp") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	--text toolbox
	button = CreateFrame("BUTTON", nil, self.Toolbox)
	self.TextButton = button
	button:SetWidth(24)
	button:SetHeight(24)
	button:SetNormalTexture(self.toolBoxIcons.text)
	button:SetHighlightTexture(self.toolBoxIcons.highLight)
	--button:SetFrameLevel(button:GetParent():GetFrameLevel() + 1)
	button:SetPoint("TOP", self.EraserButton, "BOTTOM", 0, -2)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetScript("OnClick", function(frame, mouseButton)
		self.brushTip = "Text"
		self:ToggleDrawing("draw")
	end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Icon Text") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	--title toolbox
	button = CreateFrame("BUTTON", nil, self.Toolbox)
	self.TitleButton = button
	button:SetWidth(24)
	button:SetHeight(24)
	button:SetNormalTexture(self.toolBoxIcons.title)
	button:SetHighlightTexture(self.toolBoxIcons.highLight)
	--button:SetFrameLevel(button:GetParent():GetFrameLevel() + 1)
	button:SetPoint("LEFT", self.TextButton, "RIGHT", 2, 0)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetScript("OnClick", function(frame, mouseButton)
		self.brushTip = "Title"
		self:ToggleDrawing("draw")
	end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Title Text") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	--sharing toolbox
	dropDown = CreateFrame("FRAME")
	self.ShareDropdown = dropDown
	dropDown.displayMode = "MENU"
	dropDown.initialize = function(dropDown, level) self:Toolbox_Initialization_Share(dropDown, level) end
	dropDown:Hide()
	
	button = CreateFrame("BUTTON", nil, self.Toolbox)
	self.ShareButton = button
	button:SetWidth(24)
	button:SetHeight(24)
	button:SetNormalTexture(self.toolBoxIcons.share)
	button:SetHighlightTexture(self.toolBoxIcons.highLight)
	--button:SetFrameLevel(button:GetParent():GetFrameLevel() + 1)
	button:SetPoint("TOP", self.TextButton, "BOTTOM", 0, -2)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetScript("OnClick", function(frame, mouseButton)
		if mouseButton == "RightButton" then
			ToggleDropDownMenu(1, nil, self.ShareDropdown, self.TextButton, frame:GetWidth(), frame:GetHeight())
			GameTooltip:Hide()
		end
	end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Communication Options") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	--share checkbox
	button = CreateFrame("CHECKBUTTON", nil, self.Toolbox, "UICheckButtonTemplate")
	self.ShareSendButton = button
	button:SetWidth(16)
	button:SetHeight(16)
	button:SetPoint("TOPLEFT", self.ShareButton, "BOTTOMLEFT", 0, -1)
	button.text:SetText("Share")
	button:SetScript("OnClick", function(button) self.settings.sharePaint = button:GetChecked() end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Share paint with party or raid") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	--receive checkbox
	button = CreateFrame("CHECKBUTTON", nil, self.Toolbox, "UICheckButtonTemplate")
	self.ShareReceiveButton = button
	button:SetWidth(16)
	button:SetHeight(16)
	button:SetPoint("TOPLEFT", self.ShareSendButton, "BOTTOMLEFT", 0, 3)
	button.text:SetText("Receive")
	button:SetScript("OnClick", function(button) self.settings.receivePaint = button:GetChecked() end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Receive paint from party or raid") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	--minimap icons checkbox
	button = CreateFrame("CHECKBUTTON", nil, self.Toolbox, "UICheckButtonTemplate")
	self.MinimapIconButton = button
	button:SetWidth(16)
	button:SetHeight(16)
	button:SetPoint("TOPLEFT", self.ShareReceiveButton, "BOTTOMLEFT", 0, 3)
	button.text:SetText("Minimap Icons")
	button:SetScript("OnClick", function(button) self.settings.showMinimapIcons = button:GetChecked() self:UpdateMinimapPoints() end)
	button:SetScript("OnEnter", function(button) self:Tooltip_GameTooltip_String(button, "Show icons on minimap") end)
	button:SetScript("OnLeave", function() GameTooltip:Hide() end)
		
end

function addon:LoadPaintBuckets()
	self.ColorButton = {}
	
	local function createButton(id, color, tooltipID)
		local button = CreateFrame("FRAME", nil, self.Toolbox)
		self.ColorButton[id] = button
		button:SetHeight(10)
		button:SetWidth(30)
		button:SetID(id)
		button:SetFrameLevel(button:GetParent():GetFrameLevel() + 1)
		if id == 1 then
			button:SetPoint("BOTTOMLEFT", self.Toolbox, "TOPLEFT", 0, 20)
		else
			--insert spacers
			local yOffset = 0
			if id == 13 or id == 21 then
				yOffset = 5
			end
			button:SetPoint("BOTTOMLEFT", self.ColorButton[id - 1], "TOPLEFT", 0, yOffset)
		end
		
		button:SetBackdrop({
			bgFile="Interface\\CHATFRAME\\CHATFRAMEBACKGROUND", 
			edgeFile="Interface\\CHATFRAME\\CHATFRAMEBACKGROUND", 
			tile=1, tileSize=10, edgeSize=1, 
			insets={left=0, right=0, top=0, bottom=0}
		})
		button:SetBackdropColor(color.r, color.g, color.b, 1)
		button:SetBackdropBorderColor(0, 0, 0, 1)
		
		button.heightGoal = 10 
		button.widthGoal = 30
		button.increment = 0
		
		button:SetScript("OnMouseUp", function(button)
			self.brushTip = "Paintbrush"
			self:ToggleDrawing("draw")
			self.brushColor.r = math.round(color.r, 3)
			self.brushColor.g = math.round(color.g, 3)
			self.brushColor.b = math.round(color.b, 3)
			self.selectedColorID = button:GetID()
			for buttonID, info in pairs(self.ColorButton) do
				if self.selectedColorID ~= self.ColorButton[buttonID]:GetID() then
					self.ColorButton[buttonID].heightGoal = 10
					self.ColorButton[buttonID].widthGoal = 30
					self.ColorButton[buttonID].increment = -2
				end
			end
		end)
		
		button:SetScript("OnEnter", function(button)
			button.heightGoal = 10
			button.widthGoal = 40
			button.increment = 2
			if self.colorNames[tooltipID] then
				self:Tooltip_GameTooltip_String(button, self.colorNames[tooltipID], color)
			end
		end)
		
		button:SetScript("OnLeave", function(button)
			button.heightGoal = 10 
			button.widthGoal = 30
			button.increment = -2
			if self.selectedColorID == button:GetID() then
				button.heightGoal = 10
				button.widthGoal = 40
				button.increment = 2
			end

			GameTooltip:Hide()
		end)
		
		button.throttle = 0
		button:SetScript("OnUpdate", function(button, elapsed)
			button.throttle = button.throttle + elapsed
			
			if button.throttle >= 0.03 then
				button.throttle = 0
				--height
				if math.round(button:GetHeight()) ~= button.heightGoal then
					button:SetHeight(button:GetHeight() + button.increment)
				end
				--width
				if math.round(button:GetWidth()) ~= button.widthGoal then
					button:SetWidth(button:GetWidth() + button.increment)				
				end
			end
		end)
		
		button:Show()
	end
	
	--populate the buttons with colors
	--class colors
	local id = 1
	for class, localName in pairs(LOCALIZED_CLASS_NAMES_MALE) do
		local color = RAID_CLASS_COLORS[class]
		--create button
		createButton(id, color, class)
		
		id = id + 1
	end
	
	--loot colors
	for quality = 0, 7 do
		local r, g, b, hex = GetItemQualityColor(quality)
		local color = {
			r = r,
			g = g,
			b = b
		}
		--create button
		createButton(id, color, quality)
		
		
		id = id + 1
	end
	
	--black
	local color = {r = 0, g = 0, b = 0}
	createButton(id, color, "black")
	id = id + 1
	
end

--TODO display for mirror to minimap
function addon:MiniMapAssets()
	--main background
	local frame = CreateFrame("FRAME", addonString.."_MinimapDisplay", UIParent)
	self.MinimapDisplay = frame
	local inset = 20
	frame:SetPoint("TOPLEFT", Minimap, "TOPLEFT", inset, -inset)
	frame:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", -inset, inset)
	frame:Show()
end

--TODO roll this into the other function or something
function addon:MinimapCreateFrame(id, info)
	if not self.minimapTextures[id] then
		local frame
		frame = CreateFrame("FRAME", nil, self.MinimapDisplay)
		self.minimapTextures[id] = frame
		
		frame.arrow = frame:CreateTexture("Arrow", nil, nil, 1)
		frame.arrow:SetPoint("CENTER")
		frame.arrow:SetTexture("Interface\\Addons\\"..addonString.."\\RotatingMinimapArrow.blp")
		frame.arrow:SetWidth(64)
		frame.arrow:SetHeight(64)
		frame.arrow:Hide()
		
		frame.icon = frame:CreateTexture("Icon", nil, nil, 1)
		frame.icon:SetPoint("CENTER")
					
		frame:SetWidth(16)
		frame:SetHeight(16)
		
		frame:SetID(id)
		frame:EnableMouse(false)
		frame:SetScript("OnEnter", function(frame) self:Texture_OnEnter(frame) end)
		frame:SetScript("OnLeave", function() GameTooltip:Hide() end)
		
		frame:SetScript("OnUpdate", function(frame) self:MinimapIconArrowUpdate(frame) end)
		
	end
	local frame = self.minimapTextures[id]
	
	--frame:SetPoint("CENTER", UIParent, "TOPLEFT")
	
	frame.x = info.x / self.Canvas:GetWidth()
	frame.y = info.y /  self.Canvas:GetHeight()
	--SETUP DEFAULTS HERE THEN APPLY STUFF DEPENDING ON INFO
	frame.textString = nil
	frame:EnableMouse(false)
		
	--is an icon
	if info.iconID then
		--frame:SetFrameLevel(self.frameLevels.icon)
		if type(self.iconList[info.iconID]) == "table" then
			frame.icon:SetTexture(self.iconList[info.iconID].texture)
			frame.icon:SetTexCoord(self.iconList[info.iconID].left, self.iconList[info.iconID].right, self.iconList[info.iconID].top, self.iconList[info.iconID].bottom)
			frame.icon:SetWidth(self.iconList[info.iconID].size)
			frame.icon:SetHeight(self.iconList[info.iconID].size)
		else
			frame.icon:SetTexture(self.iconList[info.iconID])
			frame.icon:SetTexCoord(0, 1, 0, 1)
			frame.icon:SetWidth(24 * 2/3)
			frame.icon:SetHeight(24 * 2/3)
		end
		frame.icon:SetVertexColor(1, 1, 1, 1)
		frame:EnableMouse(true)
	end
	
	--icon has tooltip
	if info.text then
		frame:SetFrameLevel(self.frameLevels.textIcon)
		frame.textString = info.text
	end
			
	frame:Hide()
end

function addon:ToggleDrawing(modeForce)
	self:StopDrawing()
	
	local function hide()
		self.Canvas:Hide()
		self.LowerCanvas:Hide()
		self.Canvas:EnableMouse(false)
		self:EnableMouse(false)
		self.BrushGraphic:Hide()
		
		self:UpdateMinimapPoints()
	end	
	local function draw()
		self.Canvas:Show()
		self.LowerCanvas:Show()
		self.Canvas:EnableMouse(true)
		self:WorldMapFrameLevels()
		self.BrushGraphic:Show()
	end
	
	if modeForce then
		if modeForce == "hide" then
			hide()
		else
			draw()
		end
	else
		if self.Canvas:IsVisible() then
			hide()
		else
			draw()
		end
	end
	
	self:UpdateButtons()
end

--[[

DROPDOWN INITIALIZATION

]]

function addon:Toolbox_Initialization_Paintbrush(dropDown, level)
	if level == 1 then
		local info = UIDropDownMenu_CreateInfo()
		info.text = "Custom Color "
		info.notClickable = true
		info.hasColorSwatch = true
		info.notCheckable = true
		info.r = self.brushColor.r
		info.g = self.brushColor.g
		info.b = self.brushColor.b
		info.swatchFunc = function()
			self.brushTip = "Paintbrush"
			local r, g, b = ColorPickerFrame:GetColorRGB()
			self.brushColor.r = math.round(r, 3)
			self.brushColor.g = math.round(g, 3)
			self.brushColor.b = math.round(b, 3)
		end
		info.cancelFunc = function(prev)
			self.brushColor.r = prev.r
			self.brushColor.g = prev.g
			self.brushColor.b = prev.b
		end
		UIDropDownMenu_AddButton(info, level)
			
		--class colors
		local info = UIDropDownMenu_CreateInfo()
		info.text = "Class Colors"
		info.value = "Class"
		info.keepShownOnClick = true
		info.hasArrow = true
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
		
		--loot colors
		info = UIDropDownMenu_CreateInfo()
		info.text = "Loot Colors"
		info.value = "Loot"
		info.keepShownOnClick = true
		info.hasArrow = true
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
		
		--default white
		info = UIDropDownMenu_CreateInfo()
		info.text = "White"
		info.notCheckable = true
		info.func = function()
			self.brushTip = "Paintbrush"
			self.brushColor.r = 1
			self.brushColor.g = 1
			self.brushColor.b = 1
			CloseDropDownMenus()
		end
		UIDropDownMenu_AddButton(info, level)
		
		--black
		info = UIDropDownMenu_CreateInfo()
		info.text = "Black"
		info.notCheckable = true
		info.func = function()
			self.brushTip = "Paintbrush"
			self.brushColor.r = 0
			self.brushColor.g = 0
			self.brushColor.b = 0
			CloseDropDownMenus()
		end
		UIDropDownMenu_AddButton(info, level)
	
	elseif level == 2 then
		if UIDROPDOWNMENU_MENU_VALUE == "Class" then
			local function textColor(color)
				local r, g, b = color.r, color.g, color.b
				return string.format("|cFF%02x%02x%02x", r*255, g*255, b*255)
			end

			for class, localName in pairs(LOCALIZED_CLASS_NAMES_MALE) do
				local color = RAID_CLASS_COLORS[class]
				local info = UIDropDownMenu_CreateInfo()
				info.text = localName
				info.colorCode = textColor(color)
				info.notCheckable = true
				info.func = function()
					self.brushTip = "Paintbrush"
					self.brushColor.r = math.round(color.r, 3)
					self.brushColor.g = math.round(color.g, 3)
					self.brushColor.b = math.round(color.b, 3)
					CloseDropDownMenus()
				end
				UIDropDownMenu_AddButton(info, level)
			end	
		elseif UIDROPDOWNMENU_MENU_VALUE == "Loot" then
			--build list of loot colors
			for quality = 0, 7 do
				local r, g, b, hex = GetItemQualityColor(quality)
				local info = UIDropDownMenu_CreateInfo()
				info.text = self.lootQuality[quality]
				info.colorCode = "|c"..hex
				info.notCheckable = true
				info.func = function()
					self.brushTip = "Paintbrush"
					self.brushColor.r = math.round(r, 3)
					self.brushColor.g = math.round(g, 3)
					self.brushColor.b = math.round(b, 3)
					CloseDropDownMenus()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end
end

function addon:Toolbox_Initialization_Eraser(dropDown, level)

	--point counting function for display below
	local function pointCount(contID, areaID, floorID)
		local pointCount = 0
		for _, grid in pairs(self.textureList[contID][areaID][floorID]) do
			if type(grid) == "table" then
				for point in pairs(grid) do
					pointCount = pointCount + 1
				end
			end
		end
		
		return pointCount
	end
	
	if level == 1 then
		--erase current canvas
		info = UIDropDownMenu_CreateInfo()
		info.text = CANVAS_ERASEMENU_CLEARCURRENT
		info.value = info.text
		info.keepShownOnClick = true
		info.hasArrow = true
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
		
		--erase specific canvas
		local info = UIDropDownMenu_CreateInfo()
		info.text = CANVAS_ERASEMENU_CLEARSPECIFIC
		info.value = info.text
		info.keepShownOnClick = true
		info.hasArrow = true
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
		
		--erase all data
		info = UIDropDownMenu_CreateInfo()
		info.text = CANVAS_ERASEMENU_CLEARALL
		info.value = info.text
		info.keepShownOnClick = true
		info.hasArrow = true
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
		
	elseif level == 2 then
		--list of continents
		if UIDROPDOWNMENU_MENU_VALUE == CANVAS_ERASEMENU_CLEARSPECIFIC then
			for contID, _ in pairs(self.textureList) do
				local info = UIDropDownMenu_CreateInfo()
				info.text = format(CANVAS_ERASEMENU_CONTINENT, self.continentList[contID] or contID)
				info.value = contID
				info.keepShownOnClick = true
				info.hasArrow = true
				info.notCheckable = true
				UIDropDownMenu_AddButton(info, level)
			end
		
		elseif UIDROPDOWNMENU_MENU_VALUE == CANVAS_ERASEMENU_CLEARALL then
			--ERASE EVERYTHING CONFIRMATION
			local info = UIDropDownMenu_CreateInfo()
			info.text = CANVAS_ERASEMENU_CONFIRM
			info.colorCode = "|cFFFF0000"
			info.func = function() 
				self:EraseAllCanvas()
				CloseDropDownMenus()
			end
			info.notCheckable = true
			UIDropDownMenu_AddButton(info, level)
			
		elseif UIDROPDOWNMENU_MENU_VALUE == CANVAS_ERASEMENU_CLEARCURRENT then
			--ERASE CURRENT CANVAS CONFIRMATION
			local info = UIDropDownMenu_CreateInfo()
			info.text = CANVAS_ERASEMENU_CONFIRM
			info.colorCode = "|cFFFF0000"
			info.func = function() 
				self:EraseCanvas(self.contID, self.areaID, self.floorID)
				CloseDropDownMenus()
			end
			info.notCheckable = true
			UIDropDownMenu_AddButton(info, level)
		end
		
	elseif level == 3 then
		--list of areas within a continent
		local contID = UIDROPDOWNMENU_MENU_VALUE
		self.eraserLoc.contID = contID
		for areaID in pairs(self.textureList[contID]) do
			local areaName = GetMapNameByID(areaID)
			if areaName then
				local info = UIDropDownMenu_CreateInfo()
				info.text = format(CANVAS_ERASEMENU_AREA, areaName)
				info.value = areaID
				info.keepShownOnClick = true
				info.hasArrow = true
				info.notCheckable = true
				UIDropDownMenu_AddButton(info, level)
			else
				local info = UIDropDownMenu_CreateInfo()
				info.text = CANVAS_ERASEMENU_CONFIRM
				info.colorCode = "|cFFFF0000"
				info.func = function() 
					self:EraseCanvas(contID, areaID, 0)
					CloseDropDownMenus()
				end
				info.notCheckable = true
				UIDropDownMenu_AddButton(info, level)
			end
		end
		
	elseif level == 4 then
		local areaID = UIDROPDOWNMENU_MENU_VALUE
		self.eraserLoc.areaID = areaID
		
		--list of floors within an area
		for floorID, _ in pairs(self.textureList[self.eraserLoc.contID][areaID]) do
			local pointCount = pointCount(self.eraserLoc.contID, areaID, floorID)
			if floorID > 0 then
				--it has floors
				if pointCount > 0 then
					local info = UIDropDownMenu_CreateInfo()
					local location = self.textureList[self.eraserLoc.contID][areaID][floorID].label or floorID
					info.text = format(CANVAS_ERASEMENU_FLOOR, location, pointCount)
					info.value = floorID
					info.keepShownOnClick = true
					info.hasArrow = true
					info.notCheckable = true
					UIDropDownMenu_AddButton(info, level)
				end
			else
				if pointCount > 0 then
					--its just a regular area
					local info = UIDropDownMenu_CreateInfo()
					info.text =  format(CANVAS_ERASEMENU_POINTS, pointCount)
					info.value = floorID
					info.keepShownOnClick = true
					info.hasArrow = true
					info.notCheckable = true
					UIDropDownMenu_AddButton(info, level)
				end
			end
		end
	
	elseif level == 5 then
		local floorID = UIDROPDOWNMENU_MENU_VALUE
		--ERASE SELECTED CANVAS CONFIRMATION
		local info = UIDropDownMenu_CreateInfo()
		info.text = CANVAS_ERASEMENU_CONFIRM
		info.colorCode = "|cFFFF0000"
		info.func = function() 
			self:EraseCanvas(self.eraserLoc.contID, self.eraserLoc.areaID, floorID)
			CloseDropDownMenus()
		end
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
	end
end

function addon:Toolbox_Initialization_Icon(dropDown, level)
	if level == 1 then
		local info = UIDropDownMenu_CreateInfo()
		info.text = "Raid"
		info.value = "Raid"
		info.keepShownOnClick = true
		info.hasArrow = true
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
		
		info = UIDropDownMenu_CreateInfo()
		info.text = "Tracking"
		info.value = "Tracking"
		info.keepShownOnClick = true
		info.hasArrow = true
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
		
		info = UIDropDownMenu_CreateInfo()
		info.text = "Ping Map"
		info.value = "Ping Map"
		info.notCheckable = true
		info.func = function()
			self.brushTip = "Ping"
			CloseDropDownMenus()
		end
		UIDropDownMenu_AddButton(info, level)
	
	elseif level == 2 then
		if UIDROPDOWNMENU_MENU_VALUE == "Tracking" then
			--build list of tracking icons
			for id = 1, 15 do
				local icon = self.iconList[id]
				local iconString
				if type(icon) == "table" then
					iconString = "|T"..icon.texture..":20:20:0:0:"..icon.dimX..":"..icon.dimY..":"..math.floor(icon.dimX * icon.left)..":"..math.floor(icon.dimX * icon.right)..":"..math.floor(icon.dimY * icon.top)..":"..math.floor(icon.dimY * icon.bottom).."|t"
				else
					iconString = "|T"..icon..":24|t"
				end
				local info = UIDropDownMenu_CreateInfo()
				info.text = iconString
				info.value = id
				info.checked = function()
				if self.brushIcon == info.value then
						return true
					else
						return false
					end
				end
				info.func = function()
					self.brushTip = "Icon Stamp"
					self.brushIcon = id
					CloseDropDownMenus()
				end
			UIDropDownMenu_AddButton(info, level)
			end
			
		elseif UIDROPDOWNMENU_MENU_VALUE == "Raid" then
			--build list of raid icons
			for id = 100, 107 do
				local icon = self.iconList[id]
				local iconString
				if type(icon) == "table" then
					iconString = "|T"..icon.texture..":20:20:0:0:"..icon.dimX..":"..icon.dimY..":"..math.floor(icon.dimX * icon.left)..":"..math.floor(icon.dimX * icon.right)..":"..math.floor(icon.dimY * icon.top)..":"..math.floor(icon.dimY * icon.bottom).."|t"
				else
					iconString = "|T"..icon..":24|t"
				end
				local info = UIDropDownMenu_CreateInfo()
				info.text = iconString
				info.value = id
				info.checked = function()
				if self.brushIcon == info.value then
						return true
					else
						return false
					end
				end
				info.func = function()
					self.brushTip = "Icon Stamp"
					self.brushIcon = id
					CloseDropDownMenus()
				end
			UIDropDownMenu_AddButton(info, level)
			end
			
		end		
	end
end

function addon:Toolbox_Initialization_Text(dropDown, level)
	if level == 1 then
		--text tool
		local info = UIDropDownMenu_CreateInfo()
		info.text = "Icon Text"
		info.notCheckable = true
		info.func = function()
			self.brushTip = "Text"
			self.lastText = "Text"
			CloseDropDownMenus()
		end
		UIDropDownMenu_AddButton(info, level)
		
		--title tool
		local info = UIDropDownMenu_CreateInfo()
		info.text = "Add Title"
		info.notCheckable = true
		info.func = function()
			self.brushTip = "Title"
			self.lastText = "Title"
			CloseDropDownMenus()
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function addon:Toolbox_Initialization_Share(dropDown, level)
	if level == 1 then
		--TODO remove
		local info = UIDropDownMenu_CreateInfo()
		info.text = "Send"
		info.isNotRadio = true
		info.keepShownOnClick = true
		info.checked = self.settings.sharePaint
		info.func = function()
			self.settings.sharePaint = not self.settings.sharePaint
		end
		--UIDropDownMenu_AddButton(info, level)
		
		local info = UIDropDownMenu_CreateInfo()
		info.text = "Receive"
		info.keepShownOnClick = true
		info.isNotRadio = true
		info.checked = self.settings.receivePaint
		info.func = function()
			self.settings.receivePaint = not self.settings.receivePaint
		end
		--UIDropDownMenu_AddButton(info, level)
		
		local info = UIDropDownMenu_CreateInfo()
		info.text = "Leaders Only"
		info.keepShownOnClick = true
		info.isNotRadio = true
		info.checked = self.settings.receiveLeaderOnly
		info.func = function()
			self.settings.receiveLeaderOnly = not self.settings.receiveLeaderOnly
		end
		UIDropDownMenu_AddButton(info, level)
			local info = UIDropDownMenu_CreateInfo()
			info.text = "Players"
			info.value = "Players"
			info.keepShownOnClick = true
			info.hasArrow = true
			info.notCheckable = true
			
			local senderCount = 0
			for name in pairs(self.settings.senderList) do
				senderCount = senderCount + 1
			end
			if senderCount == 0 then
				info.disabled = true
			end
			UIDropDownMenu_AddButton(info, level)
		
	elseif level == 2 then
		if UIDROPDOWNMENU_MENU_VALUE == "Players" then
			for name, isFriend in pairs(self.settings.senderList) do
				local info = UIDropDownMenu_CreateInfo()
				info.text = name
				info.isNotRadio = true
				info.checked = self.settings.senderList[name]
				info.keepShownOnClick = true
				info.func = function()
					self.settings.senderList[name] = not self.settings.senderList[name]
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end	
	end
end

function addon:ShowStaticPopup(popupName, text, button1, button2, OnAccept, OnCancel, hideOnEscape, timeout)
	StaticPopupDialogs[popupName] = {
		text = text,
		button1 = button1,
		button2 = button2,
		OnAccept = OnAccept,
		OnCancel = OnCancel,
		hideOnEscape = hideOnEscape,
		timeout = timeout,
	}
	StaticPopup_Show(popupName)
end

function addon:CopyTable(oldTable, meta, deep)
	local result = {}

	for key, value in pairs(oldTable) do
		if type(value) == "table" and deep then
			result[key] = self:CopyTable(value, meta, deep)
		else
			result[key] = value
		end
	end

    -- copy the metatable, if there is one
	if meta then
		setmetatable(result, getmetatable(oldTable))
	end
	
	return result
end

--clean up table and parents if necessary
function addon:CleanTable(contID, areaID, floorID)
	--clean up canvas table
	if self:AreaExists(contID, areaID, floorID) then
		self:CleanTable_Floor(contID, areaID, floorID)
		
	elseif self.textureList[contID][areaID] then
		self:CleanTable_Area(contID, areaID)

	elseif self.textureList[contID] then
		self:CleanTable_Cont(contID)
	end
end

--clear the continent if there are no areas left
function addon:CleanTable_Cont(contID)
	local contCount = 0
	for _, _ in pairs(self.textureList[contID]) do
		contCount = contCount + 1
	end
	
	if contCount == 0 then
		self.textureList[contID] = nil
	end
end

--clear the area if no floors are left
function addon:CleanTable_Area(contID, areaID)
	local areaCount = 0
	for _, _ in pairs(self.textureList[contID][areaID]) do
		areaCount = areaCount + 1
	end
	
	if areaCount == 0 then
		self.textureList[contID][areaID] = nil
		
		self:CleanTable_Cont(contID)
	end
end

--clear the floor if there are no points left
function addon:CleanTable_Floor(contID, areaID, floorID)
	local floorCount = 0
	for grid, info in pairs(self.textureList[contID][areaID][floorID]) do
		if type(info) == "table" then
			local pointCount = 0
			for point in pairs(info) do
				pointCount = pointCount + 1
			end
			
			if pointCount > 0 then
				floorCount = floorCount + 1
			else
				self.textureList[contID][areaID][floorID][grid] = nil
			end
		end
	end
	
	if floorCount == 0 then
		self.textureList[contID][areaID][floorID] = nil
		
		self:CleanTable_Area(contID, areaID)
	end
end

--apply text to selected icon if appropriate
function addon:Texture_OnClick(frame)
	if self.Canvas:IsVisible() and self.brushTip == "Text" then
		self:ApplyText(frame)
	end
end

--show the text for an icon
function addon:Texture_OnEnter(frame)
	if not self.Canvas:IsVisible() or self.brushTip == "Text" then
		--not editting, show tooltip
		if frame.textString then
			GameTooltip:SetOwner(frame, "ANCHOR_RIGHT")
			GameTooltip:SetText(frame.textString, 1, 1, 1, 1, true)
			GameTooltip:Show()
		end
	end
end

--enable/disable mouse interaction of a point 
function addon:Texture_OnUpdate(frame)
	if frame.mouseEnable then
		if self.Canvas:IsVisible() then
			if self.brushTip == "Paintbrush" then
				frame:EnableMouse(false)
				
			elseif self.brushTip == "Eraser" then
				frame:EnableMouse(false)
			
			elseif self.brushTip == "Icon Stamp" then
				frame:EnableMouse(true)
				
			elseif self.brushTip == "Text" then
				frame:EnableMouse(true)
			
			elseif self.brushTip == "Title" then
				frame:EnableMouse(false)
				
			else
				frame:EnableMouse(false)
			end
		else
			frame:EnableMouse(true)
		end
	else
		frame:EnableMouse(false)
	end
end

--receive canvas info
function addon:AddonComm_Receive(message, sender)
	local msgType, msgInfo = strsplit("\a", message, 2)
		
	if msgType == "line" then
		--paint
		local contID, areaID, floorID, x1, y1, x2, y2, r, g, b = strsplit("\a", msgInfo)
		contID, areaID, floorID = tonumber(contID), tonumber(areaID), tonumber(floorID)
		x1 = tonumber(x1)
		x2 = tonumber(x2)
		y1 = tonumber(y1)
		y2 = tonumber(y2)
		r = tonumber(r)
		g = tonumber(g)
		b = tonumber(b)
		
		self:DrawLine(x1, y1, x2, y2, r, g, b, contID, areaID, floorID, sender)
		
	elseif msgType == "icon" then
		--icon
		local contID, areaID, floorID, x, y, iconID, uniqueID = strsplit("\a", msgInfo)
		contID, areaID, floorID = tonumber(contID), tonumber(areaID), tonumber(floorID)
		x = tonumber(x)
		y = tonumber(y)
		iconID = tonumber(iconID)
		uniqueID = tonumber(uniqueID)

		self:DrawIcon(x, y, iconID, nil, contID, areaID, floorID, uniqueID, sender)
		
	elseif msgType == "erase" then
		--erase
		local contID, areaID, floorID, x, y, eraserSize = strsplit("\a", msgInfo)
		contID, areaID, floorID = tonumber(contID), tonumber(areaID), tonumber(floorID)
		timeID = time()
		x = tonumber(x)
		y = tonumber(y)
		eraserSize = tonumber(eraserSize)

		self:EraseLocation(x, y, eraserSize, contID, areaID, floorID, timeID, sender)
	
	elseif msgType == "text" then
		--update an icon with text
		local contID, areaID, floorID, text, uniqueID, x, y = strsplit("\a", msgInfo)
		contID, areaID, floorID = tonumber(contID), tonumber(areaID), tonumber(floorID)
		uniqueID = tonumber(uniqueID)
		x = tonumber(x)
		y = tonumber(y)
		
		--TODO remove and replace with existing function?
		if self:AreaExists(contID, areaID, floorID) then
		
			local searching = true
			local gridID = self:GetGridLocation(x, y)
			for point, info in pairs(self.textureList[contID][areaID][floorID][gridID]) do
				if searching then
					if type(info) == "table" then
						if info.uniqueID == uniqueID then		--may want to make this check another variable too
							searching = false
							info.text = text
							if self:AreaConfirm(contID, areaID, floorID) then
								self:DrawPoint(info.id, info)
								self.textures[info.id]:Show()
							end
						end
					end
				else
					return
				end				
			end
		end
	
	elseif msgType == "title" then
		--place a title
		local contID, areaID, floorID, x, y, title = strsplit("\a", msgInfo)
		contID, areaID, floorID = tonumber(contID), tonumber(areaID), tonumber(floorID)
		x = tonumber(x)
		y = tonumber(y)
		
		self:AddTitle(x, y, contID, areaID, floorID, title, sender)
	
	elseif msgType == "ping" then
		--place a ping
		local contID, areaID, floorID, x, y = strsplit("\a", msgInfo)
		contID, areaID, floorID = tonumber(contID), tonumber(areaID), tonumber(floorID)
		x = tonumber(x)
		y = tonumber(y)
		
		self:AddPing(x, y, contID, areaID, floorID, sender)
	
	--end of msg types
	end
end

--send canvas info
function addon:AddonComm_Send(info, ...)
	local channel, target = ...
	local priority = "NORMAL"
	local message
	local delimiter = "\a"
	for x = 1, #info do
		if message then
			message = message..delimiter..tostring(info[x])
		else
			message = tostring(info[x])
		end
	end
	
	if channel == "WHISPER" then
		if UnitIsConnected(target) then
			local packet = {
				message = message,
				channel = channel,
				target = target,
			}
			table.insert(self.outboundInfo, packet)
		end
	else
		if GetNumGroupMembers() > 0 then
			if IsInRaid() then
				local packet = {
				message = message,
				channel = "RAID",
				target = target,
			}
			table.insert(self.outboundInfo, packet)
			else
				local packet = {
				message = message,
				channel = "PARTY",
				target = target,
			}
			table.insert(self.outboundInfo, packet)
			end
		else
			--send the message to yourself
			ChatThrottleLib:SendAddonMessage(priority, addonString, message, "WHISPER", UnitName("player"))
		end
	end
end

--create the table to hold canvas info
function addon:CreateCanvas(contID, areaID, floorID)
	if not self.textureList[contID] then
		self.textureList[contID] = {}
	end
		
	if not self.textureList[contID][areaID] then
		self.textureList[contID][areaID] = {}
	end
	
	if not self.textureList[contID][areaID][floorID] then
		self.textureList[contID][areaID][floorID] = {}
		if floorID > 0 then
			self.textureList[contID][areaID][floorID].label = WorldMapLevelDropDownText:GetText() or nil
		end
	end
end

--update button highlights to show tool selection
function addon:UpdateButtons()
	--setup
	self.PaintbrushButton:UnlockHighlight()
	self.EraserButton:UnlockHighlight()
	self.IconButton:UnlockHighlight()
	self.TextButton:UnlockHighlight()
	self.TitleButton:UnlockHighlight()
	self.PingButton:UnlockHighlight()
	
	--sharing checkboxes
	self.ShareSendButton:SetChecked(self.settings.sharePaint)
	self.ShareReceiveButton:SetChecked(self.settings.receivePaint)
	self.MinimapIconButton:SetChecked(self.settings.showMinimapIcons)

	if self.Canvas:IsVisible() then
		if self.brushTip == "Paintbrush" then
			self.PaintbrushButton:LockHighlight()
			
		elseif self.brushTip == "Eraser" then
			self.EraserButton:LockHighlight()
			
		elseif self.brushTip == "Icon Stamp" then
			self.IconButton:LockHighlight()
			
		elseif self.brushTip == "Ping" then
			self.PingButton:LockHighlight()
			
		elseif self.brushTip == "Text" then
			self.TextButton:LockHighlight()
			
		elseif self.brushTip == "Title" then
			self.TitleButton:LockHighlight()	
		end
	end
end

--increment the canvas count or return false if its over cap
function addon:CanvasPointIncrement(canvas)
	if not canvas.count then
		canvas.count = 0
	end
	
	if canvas.count >= self.textureCountCap then
		return false
	else
		canvas.count = canvas.count + 1
	end
	return true
end

--decrement the canvas count or create a new count if it doesnt exist
function addon:CanvasPointDecrement(canvas)
	if not canvas.count then
		canvas.count = 0
	else
		if canvas.count > 0 then
			canvas.count = canvas.count - 1
		else
			canvas.count = 0
		end
	end
	return true
end

--return the grid name, grid x and grid y
function addon:GetGridLocation(canvasX, canvasY)	
	local posX = math.floor(canvasX / self.gridSize)
	local posY = math.floor(canvasY / self.gridSize)
	
	local gridID = (posX * 100) + posY
	
	return gridID, posX, posY
end

--confirm or create grid for canvas
function addon:CreateGrid(canvas, grid)
	if not canvas[grid] then
		canvas[grid] = {}
	else
		return true
	end
end

function addon:SurroundingGrids(gridID)
	local surroundingGrids = {
		topLeft = gridID - 99,
		top = gridID + 1, 
		topRight = gridID + 101, 
		
		left = gridID - 100, 
		center = gridID,
		right = gridID + 100, 
		
		bottomLeft = gridID - 101, 
		bottom = gridID - 1, 
		bottomRight = gridID + 99, 
	}
	
	return surroundingGrids
end

function addon:Tooltip_GameTooltip_String(frame, text, color)
	if not color or ( color.r == 0 and color.g == 0 and color.b == 0 ) then color = {r = 1, g = 1, b = 1} end
	
	if frame and text then
		GameTooltip:SetOwner(frame, "ANCHOR_RIGHT")
		GameTooltip:SetText(text, color.r or 1, color.g or 1, color.b or 1, 1, true)
		GameTooltip:Show()
	end
end

function addon:UpdateMinimapPoints()
	--hide all frames
	for id, frame in pairs(self.minimapTextures) do
		Pins:RemoveMinimapIcon("Canvas", frame)
		frame.arrow:Hide()
		frame:Hide()
	end
	local x, y, areaID, floorID = HBD:GetPlayerZonePosition()
	local contID = GetCurrentMapContinent()
	
	if self.settings.showMinimapIcons and contID and areaID and floorID then
		self.MinimapDisplay:SetScale(Minimap:GetEffectiveScale() / UIParent:GetEffectiveScale())
		--apply data and display frames
		
		if self:AreaExists(contID, areaID, floorID) then
			local id = 1
			for _, grid in pairs(self.textureList[contID][areaID][floorID]) do
				if type(grid) == "table" then
					for point, info in pairs(grid) do
						--icons only
						if info.iconID then
							self:MinimapCreateFrame(id, info)
							
							local frame = self.minimapTextures[id]
							frame:Show()
							Pins:AddMinimapIconMF("Canvas", frame, areaID, floorID, frame.x, 1 - frame.y, info.iconID and true)
													
							id = id + 1
						end
					end
				end
			end
		end
	end
end

--update arrow for displayed minimap icon. inset from edge to compensate for arrow
function addon:MinimapIconArrowUpdate(frame)
	if Pins:IsMinimapIconOnEdge(frame) then
		frame.arrow:Show()
		
		--get rotation and alter for rotating map
		local rotation = Pins:GetVectorToIcon(frame)
		if GetCVar("rotateMinimap") == "1" then
			rotation = rotation - GetPlayerFacing()
		end
		frame.arrow:SetRotation(rotation)
		
		local offsetDist = 10
		local x, y = math.sin(rotation - math.pi) * offsetDist, math.cos(rotation - math.pi) * offsetDist
		frame.arrow:SetPoint("CENTER", -x, y)
		frame.icon:SetPoint("CENTER", -x, y)
	else
		frame.arrow:SetPoint("CENTER")
		frame.icon:SetPoint("CENTER")
		frame.arrow:Hide()
	end
end





















